# coding: utf-8

"""
    Project Service New Version API

    Exposed REST API for operations with multi scope secrets  # noqa: E501

    OpenAPI spec version: 2023-01-01
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ApiSecretsBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'description': 'str',
        'value': 'str',
        'project_ids_to_add': 'list[str]',
        'org_scoped': 'bool'
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'value': 'value',
        'project_ids_to_add': 'projectIdsToAdd',
        'org_scoped': 'orgScoped'
    }

    def __init__(self, name=None, description=None, value=None, project_ids_to_add=None, org_scoped=None):  # noqa: E501
        """ApiSecretsBody - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._description = None
        self._value = None
        self._project_ids_to_add = None
        self._org_scoped = None
        self.discriminator = None
        self.name = name
        if description is not None:
            self.description = description
        self.value = value
        if project_ids_to_add is not None:
            self.project_ids_to_add = project_ids_to_add
        if org_scoped is not None:
            self.org_scoped = org_scoped

    @property
    def name(self):
        """Gets the name of this ApiSecretsBody.  # noqa: E501

        A human-friendly name used as an identifier for a secret. Secret name should not contain special characters.  # noqa: E501

        :return: The name of this ApiSecretsBody.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ApiSecretsBody.

        A human-friendly name used as an identifier for a secret. Secret name should not contain special characters.  # noqa: E501

        :param name: The name of this ApiSecretsBody.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def description(self):
        """Gets the description of this ApiSecretsBody.  # noqa: E501

        A human-friendly description.  # noqa: E501

        :return: The description of this ApiSecretsBody.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this ApiSecretsBody.

        A human-friendly description.  # noqa: E501

        :param description: The description of this ApiSecretsBody.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def value(self):
        """Gets the value of this ApiSecretsBody.  # noqa: E501

        The value of secret.  # noqa: E501

        :return: The value of this ApiSecretsBody.  # noqa: E501
        :rtype: str
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this ApiSecretsBody.

        The value of secret.  # noqa: E501

        :param value: The value of this ApiSecretsBody.  # noqa: E501
        :type: str
        """
        if value is None:
            raise ValueError("Invalid value for `value`, must not be `None`")  # noqa: E501

        self._value = value

    @property
    def project_ids_to_add(self):
        """Gets the project_ids_to_add of this ApiSecretsBody.  # noqa: E501

        A list of project IDs to add this secret to.  # noqa: E501

        :return: The project_ids_to_add of this ApiSecretsBody.  # noqa: E501
        :rtype: list[str]
        """
        return self._project_ids_to_add

    @project_ids_to_add.setter
    def project_ids_to_add(self, project_ids_to_add):
        """Sets the project_ids_to_add of this ApiSecretsBody.

        A list of project IDs to add this secret to.  # noqa: E501

        :param project_ids_to_add: The project_ids_to_add of this ApiSecretsBody.  # noqa: E501
        :type: list[str]
        """

        self._project_ids_to_add = project_ids_to_add

    @property
    def org_scoped(self):
        """Gets the org_scoped of this ApiSecretsBody.  # noqa: E501

        This boolean checks if the secret is org scope or project scope  # noqa: E501

        :return: The org_scoped of this ApiSecretsBody.  # noqa: E501
        :rtype: bool
        """
        return self._org_scoped

    @org_scoped.setter
    def org_scoped(self, org_scoped):
        """Sets the org_scoped of this ApiSecretsBody.

        This boolean checks if the secret is org scope or project scope  # noqa: E501

        :param org_scoped: The org_scoped of this ApiSecretsBody.  # noqa: E501
        :type: bool
        """

        self._org_scoped = org_scoped

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ApiSecretsBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ApiSecretsBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
